//
//   IP.h
//

#ifndef TelnetDef
#define TelnetDef 1

#include <windows.h>
#include <stdio.h>
#include <vector>
#include <winsock2.h>

#include "..\UtilsLib\main_classes.h"
#include "..\UtilsLib\status_bar.h"
#include "..\UtilsLib\controls.h"
#include "..\UtilsLib\lng.h"
#include "..\UtilsLib\abstract_model.h"

#include "config.h"


#define  Terminal_IP_Adapter_CLASS_NAME    "Terminal_IP_Adapter"
#define  Terminal_IP_Adapter_OBJECT_TYPE   "Terminal_IP_Adapter"


class Terminal_IP_Adapter : protected ToolClass, protected TicksUserClass, protected FastTicksUserClass {
public:
	static const char* const CLASS_NAME; 
	
	static const char* const OBJECT_TYPE; 
	static ObjectClass*      ObjectConstructor( ConfigInterface*, const char *acAlias );
	static InternalsType     InternalsRoot;

	static InternalsPointersVectorType  vInternalsPointers;
	static InternalsPointersMapType     mInternalsPointers;


protected:
	virtual ~Terminal_IP_Adapter();

//	IntegerConstant  nC_SecondsToWaitAtPrompt;
//	StringParameter  sP_ScriptFile;
//	StateVarType     St_Load;

	void ByteReceiver( PVOID pData, SocketClass *pSender );

	Input_SocketClass         ByteInputSocket;
	Output_SocketClass        ByteOutputSocket;

	TextOutput_SocketClass    Log;
	
	SOCKET  ServerSocket;
	SOCKET  ClientSocket;
	SOCKET  RemoteSocket;
	
	void Tick();
	void FastTick();

	void Initializer();
//	void Load_StateCallback( const char*, int );

	int  nConnectPhase;

	void TryToAcceptConnection();
	void TryToConnect();
	
	safe_string  sIP_Output;
	
	StringConstant   sC_Server_IP;
	IntegerConstant  nC_Server_Port;

	StringConstant   sC_Client_IP;
	IntegerConstant  nC_Client_Port;

	IntegerConstant  nC_ExtendedLog;
	
	int nMesCount;

private:
	Terminal_IP_Adapter( ConfigInterface *pConfigI, const char *acAlias );

	static unsigned int nObjectsCount;
};

//////////////////////////////////////////////////////////////////////////

#define  Console_IP_Adapter_CLASS_NAME    "Console_IP_Adapter"
#define  Console_IP_Adapter_OBJECT_TYPE   "Console_IP_Adapter"


class Console_IP_Adapter : protected ToolClass, protected TicksUserClass {
public:
	static const char* const CLASS_NAME; 
	
	static const char* const OBJECT_TYPE; 
	static ObjectClass*      ObjectConstructor( ConfigInterface*, const char *acAlias );
	static InternalsType     InternalsRoot;

	static InternalsPointersVectorType  vInternalsPointers;
	static InternalsPointersMapType     mInternalsPointers;


protected:
	virtual ~Console_IP_Adapter();

//	IntegerConstant  nC_SecondsToWaitAtPrompt;
//	StringParameter  sP_ScriptFile;
//	StateVarType     St_Load;

	void TextReceiver( PVOID pData, SocketClass *pSender );

	Input_SocketClass         TextInputSocket;
	Output_SocketClass        TextOutputSocket;

	TextOutput_SocketClass    Log;
	
	SOCKET  ServerSocket;
	SOCKET  ClientSocket;
	SOCKET  RemoteSocket;
	
	void Tick();

	void Initializer();

	int  nConnectPhase;

	void TryToAcceptConnection();
	void TryToConnect();
	
	safe_string      sIP_Output;
	
	StringConstant   sC_Server_IP;
	IntegerConstant  nC_Server_Port;

	StringConstant   sC_Client_IP;
	IntegerConstant  nC_Client_Port;

	IntegerConstant  nC_ExtendedLog;
	
	int nMesCount;

private:
	Console_IP_Adapter( ConfigInterface *pConfigI, const char *acAlias );

	static unsigned int nObjectsCount;
};


#endif
