//
//   LogSpeedTester.h
//

#ifndef LogSpeedTesterDef
#define LogSpeedTesterDef 1

#include <windows.h>
#include <stdio.h>
#include <vector>

#include "..\UtilsLib\main_classes.h"
#include "..\UtilsLib\status_bar.h"
#include "..\UtilsLib\controls.h"
#include "..\UtilsLib\lng.h"
#include "..\UtilsLib\abstract_model.h"

#include "config.h"


#define  LogSpeedTester_CLASS_NAME    "LogSpeedTester"
#define  LogSpeedTester_OBJECT_TYPE   "LogSpeedTester"


class LogSpeedTester : protected ToolClass, protected TicksUserClass {
public:
	static const char* const CLASS_NAME; // "LogSpeedTester"
	
	static const char* const OBJECT_TYPE; // "LogSpeedTester"
	static ObjectClass*      ObjectConstructor( ConfigInterface*, const char *acAlias );
	static InternalsType     InternalsRoot;

	static InternalsPointersVectorType  vInternalsPointers;
	static InternalsPointersMapType     mInternalsPointers;


protected:
	virtual ~LogSpeedTester()
	{
		while( bTestRunning ) { StopTest(); Sleep(1); }
	}

	StateVarType     St_Test;

	Output_SocketClass   TextOutputSocket;
	
	void Tick();
	
	void Initializer();
	void StartTest();
	void StopTest();
	void Test();
	void Test_StateCallback( const char*, int );
	
	static void TestThread( PVOID pObject )
	{
		return ((LogSpeedTester*)pObject)->Test();
	}	
	
	bool   bTestRunning;
	bool   bStopTest;
	dword  dwTestCount;
	dword  dwBytesSent;
	dword  dwPrevBytesSent;
	dword  dwLastPrintTC;

	WorkfieldOwnerStatusBarClass  *pStatusBar;

private:
	LogSpeedTester( ConfigInterface *pConfigI, const char *acAlias );

	static unsigned int nObjectsCount;
};


#endif
