//
//   UKNC_NET_Loader.h
//

#ifndef UKNC_NET_LoaderDef
#define UKNC_NET_LoaderDef 1

#include <windows.h>
#include <stdio.h>
#include <vector>

#include "..\UtilsLib\main_classes.h"
#include "..\UtilsLib\status_bar.h"
#include "..\UtilsLib\controls.h"
#include "..\UtilsLib\lng.h"
#include "..\UtilsLib\abstract_model.h"

#include "config.h"


#define  UKNC_NET_Loader_CLASS_NAME    "UKNC_NET_Loader"
#define  UKNC_NET_Loader_OBJECT_TYPE   UKNC_NET_Loader_CLASS_NAME


class UKNC_NET_Loader : protected ToolClass, protected TicksUserClass {
public:
	static const char* const CLASS_NAME; // "UKNC_NET_Loader"
	
	static const char* const OBJECT_TYPE; // "UKNC_NET_Loader"
	static ObjectClass*      ObjectConstructor( ConfigInterface*, const char *acAlias );
	static InternalsType     InternalsRoot;

	static InternalsPointersVectorType  vInternalsPointers;
	static InternalsPointersMapType     mInternalsPointers;


protected:
	virtual ~UKNC_NET_Loader(){}

	StringParameter  sP_BootFile;
	IntegerParameter nP_BytesToSend;
	StateVarType     St_Load;

	Input_SocketClass    ByteInputSocket;
	Output_SocketClass   ByteOutputSocket;
	
	void ByteReceiver( PVOID pData, SocketClass *pSender );
	int  nPhase;

	void Tick();
	
	byte   uRecivedByte;
	dword  uBytesRecived; 

	void Initializer();
	void Load_StateCallback( const char*, int );
	void Load();
	bool LoadCheck();
	bool bLoading;
	bool bClearLoadState;
	
	byte  acBuf[1024*128];
	int   nBootSize; 

private:
	UKNC_NET_Loader( ConfigInterface *pConfigI, const char *acAlias );

	static unsigned int nObjectsCount;
};


#endif
