//
//  ByteStream.h
//
#ifndef ByteStreamDefs
#define ByteStreamDefs 1

#include "main_classes.h"

//
//  ByteReceiver( PVOID pData, SocketClass *pSender )
//
//  pData -   (  ).
//
//
#define  acByteStreamType                  "ByteStream"

//
//  Commands & Replys
//
#define  acCommand_ChangeBaudRate          "ChangeBaudRate"          //  Socket.SendCommand( acCommand_ChangeBaudRate,   (PVOID)nVal           );
#define  acCommand_BaudRateChanged         "BaudRateChanged"         //  Socket.SendCommand( acCommand_BaudRateChanged,  (PVOID)nBaudRate      );
#define  acCommand_Change_CPS_Limit        "Change_CPS_Limit"        //  Socket.SendCommand( acCommand_Change_CPS_Limit, (PVOID)nVal           );
#define  acCommand_CPS_LimitChanged        "CPS_LimitChanged"        //  Socket.SendCommand( acCommand_CPS_LimitChanged, (PVOID)nCPS_Limit     );
#define  acCommand_BreakOn                 "BreakOn"                 //  Socket.SendCommand( acCommand_BreakOn,           NULL                 );
#define  acCommand_BreakOff                "BreakOff"                //  Socket.SendCommand( acCommand_BreakOff,         (PVOID)dwBreakTimeMKS );
#define  acCommand_BadFrame                "BadFrame"                //  Socket.SendCommand( acCommand_BadFrame,         (PVOID)cByte          );
#define  acCommand_ClearFIFO               "ClearFIFO"               //  Socket.SendCommand( acCommand_ClearFIFO,         NULL                 );

#define  acCommand_ReportBaudRate          "ReportBaudRate"          //  Socket.SendCommand( acCommand_ReportBaudRate,  NULL );
#define  acReply_BaudRateReported          "BaudRateReported"        //  Socket.SendReply(   acReply_BaudRateReported,  (PVOID)nBaudRate, pSender );

#define  acCommand_ReportBaudRatesArray    "ReportBaudRatesArray"    //  Socket.SendCommand( acCommand_ReportBaudRatesArray, NULL );
#define  acReply_BaudRatesArrayReported    "BaudRatesArrayReported"  //  Socket.SendReply(   acReply_BaudRatesArrayReported, (PVOID)&vnBaudRates, pSender );

#define  acCommand_Report_CPS_Limit        "Report_CPS_Limit"        //  Socket.SendCommand( acCommand_Report_CPS_Limit, NULL );
#define  acReply_CPS_LimitReported         "CPS_LimitReported"       //  Socket.SendReply(   acReply_CPS_LimitReported,  (PVOID)nCPS_Limit, pSender );

#define  acCommand_Report_CPS_LimitsArray  "Report_CPS_LimitsArray"  //  Socket.SendCommand( acCommand_Report_CPS_LimitsArray, NULL );
#define  acReply_CPS_LimitsArrayReported   "CPS_LimitsArrayReported" //  Socket.SendReply(   acReply_CPS_LimitsArrayReported,  (PVOID)&vnCPS_Limits, pSender );

#define  acCommand_ReportRunTimeMS         "Report_RunTimeMS"        //  Socket.SendCommand( acCommand_ReportRunTimeMS,  NULL );
#define  acReply_RunTimeMS_Reported        "RunTimeMS_Reported"      //  Socket.SendReply(   acReply_RunTimeMS_Reported, (PVOID)dwRunTimeMS, pSender );


///////////////////////////////////////////////////


class BytestreamChannelClass : protected SocketOwnerClass {
public:
	static const char* const CLASS_NAME; // "BytestreamChannel"

	static const char* const OBJECT_TYPE;     // "ByteStream"
	static ObjectClass*      ObjectConstructor( ConfigInterface*, const char *acAlias );
	static InternalsType     InternalsRoot;

	static InternalsPointersVectorType  vInternalsPointers;
	static InternalsPointersMapType     mInternalsPointers;

protected:
	virtual ~BytestreamChannelClass(){};

	Input_SocketClass   InputSocket;
	Output_SocketClass  OutputSocket;
    
private:
	BytestreamChannelClass( ConfigInterface *pConfig, const char *acAlias );

    //     pData -   ,   .
	void ByteReceiver( PVOID pData, SocketClass *pSender )
	{
		if( !bOutputSocketInUse )
		{
			bOutputSocketInUse = true;
			OutputSocket.Send( pData );
			bOutputSocketInUse = false;
		}
	}
	void InputSocketCommandReceiver(  const char* acCommand, PVOID pData, SocketClass *pSender )
	{
		OutputSocket.SendCommand( acCommand, pData );
	}
	void OutputSocketCommandReceiver( const char* acCommand, PVOID pData, SocketClass *pSender )
	{
		InputSocket.SendCommand( acCommand, pData );
	}
	
	bool bOutputSocketInUse;

	static unsigned int nObjectsCount;
};

#endif