//
//  ini_filer.h  -  /  .ini
//
#ifndef ini_filerDefs
#define ini_filerDefs 1

#include <windows.h>
#include "main_classes.h"

#define MAX_INI_STR_LENGTH 256


extern void WriteIniInteger( const char *ini_file, const char *key, int val, NumberType Type = DECIM, const char *sect = "Main" );
extern void WriteIniBoolean( const char *ini_file, const char *key, bool val, const char *sect = "Main" );
extern void WriteMainIniInteger( const char *key, int val, NumberType Type = DECIM, const char *sect = "Main" );
extern void WriteMainIniBoolean( const char *key, bool val, const char *sect = "Main" );
extern void WriteMainIniStr( const char *key, const char *val, const char *sect = "Main" );
extern void WriteIniStr( const char *ini_file, const char *key, const char *val, const char *sect = "Main" );
extern dword ReadIniStr( const char *ini_file, const char *key, char *buf, const char *sect = "Main" );
extern dword ReadMainIniStr( const char *key, char *buf, const char *sect = "Main" );
extern dword ReadIniSection( const char *ini_file, char *buf, dword buf_len, const char *sect = "Main" );

extern int ReadIniInteger( const char *ini_file, const char *key, int def_val, NumberType Type = DECIM, const char *sect = "Main", 
                           const std::vector<const NamedValType> *pvAllowedVals = NULL );
                           
extern int ReadIniInteger( const char *ini_file, const char *key, int def_val, NumberType Type, const char *sect, 
                           const int* anPermittedVals, int nPermittedVals, bool bCheckOnly = false );
                           
extern int ReadIniInteger( const char *ini_file, const char *key, int def_val, NumberType Type, const char *sect, int nMinVal, int nMaxVal, bool bCheckOnly = false );
extern bool ReadIniBoolean( const char *ini_file, const char *key, bool bDefVal, const char *sect = "Main" );
extern int ReadMainIniInteger( const char *key, int def_val, NumberType Type = DECIM, const char *sect = "Main" );
extern bool ReadMainIniBoolean( const char *key, const bool bDefVal, const char *sect = "Main" );

extern dword ReadIniRGB( const char *ini_file, const char *key, int def_val, const char *sect = "Main", bool bCheckOnly = false );
extern void  WriteIniRGB( const char *ini_file, const char *key, int val, const char *sect = "Main" );

extern dword ReadIni_ANSI_Str( const char *ini_file, const char *key, char *buf, const char *def_val = "", const char *sect = "Main" );
extern void  WriteIni_ANSI_Str( const char *ini_file, const char *key, const char *val, const char *sect = "Main" );

extern void DeleteIniSection( const char *ini_file, const char *sect );

#endif
