//
//   module.inc   -      .
//

#include <windows.h>
#include <commctrl.h>

#include "..\UtilsLib\main_classes.h"
#include "..\UtilsLib\lng.h"
#include "..\UtilsLib\logger.h"


#ifndef         pProgramDescriptors_Defined
#define         pProgramDescriptors_Defined
ProgramDescriptorsType  *pProgramDescriptors;
#endif


#ifndef  _qq
////////////////////////////////////////////////////////
#define _qq(a) #a
#define _q(a) _qq(a)

#define _cc2(first,last) first##last
#define _c2(first,last) _cc2(first,last)

#define _cc3(first,middle,last) first##middle##last
#define _c3(first,middle,last) _cc3(first,middle,last)
////////////////////////////////////////////////////////
#endif



#define  vpModuleInternals     _c3( vp, module_name, _Internals )
#define  mpModuleInternals     _c3( mp, module_name, _Internals )
#define  ModuleInternalsRoot   _c2( module_name, _InternalsRoot )


static InternalsPointersVectorType       vpModuleInternals;
static InternalsPointersMapType          mpModuleInternals;

InternalsType  ModuleInternalsRoot = { _q( _c2( module_name, .em ) ), "Module Internals Root", "InternalsPointersVectorType*", "0x%X", 
                                       &mpModuleInternals, (qword)&vpModuleInternals };





#ifndef  module_embedded
/////////////////////////////////////////////////
InternalsPointersVectorType  vpUtilsLibInternals;
InternalsPointersMapType     mpUtilsLibInternals;

InternalsType  UtilsLibInternals = { "UtilsLibInternals", "UtilsLib Internals", "InternalsPointersVectorType*", "0x%X", 
                                     &mpUtilsLibInternals, (qword)&vpUtilsLibInternals };
AddInternal    i_UtilsLibInternals( &vpModuleInternals, &UtilsLibInternals );


char        acModuleName[] = _q(module_name);   //       .lng     .log
char        acModulePath[4096];                 //    -     .lng
const char *acProgramPath;
HINSTANCE   ghInstance;
int         nWinSockUsers;
/////////////////////////////////////////////////
#else

char        acModulePath[];

#define        i_ModuleInternals  _c3( i_, module_name, _Internals )
AddInternal    i_ModuleInternals( &vpProgramInternals, &ModuleInternalsRoot );

#endif





#define  _ModuleUID          _c2( module_name, _UID )
#define  i_ModuleSignature   _c2( i_, _ModuleUID )

InternalsType  _ModuleUID = { "ModuleUID", "Module Signature", "char*", "%s", NULL, (qword)module_UID };
AddInternal    i_ModuleSignature( &vpModuleInternals, &_ModuleUID );




#define  _ModuleHandle       _c2( module_name, _Handle )
#define  i_ModuleHandle      _c2( i_, _ModuleHandle )

InternalsType  _ModuleHandle = { "ModuleHandle", "Module Handle", "HMODULE", "0x%X", NULL, (qword)NULL };
AddInternal    i_ModuleHandle( &vpModuleInternals, &_ModuleHandle );



#ifndef  module_embedded
//*********************************************//
InternalsType  ModuleBuild = { "ModuleBuild", "Module Build", "char*", "%s", NULL, (qword)__DATE__ " " __TIME__ };
AddInternal    i_ModuleBuild( &vpModuleInternals, &ModuleBuild );


#ifdef _DEBUG
InternalsType  ModuleDebugMode = { "DebugMode", "Debug Mode", "bool", "%i", NULL, 1 };
#else
InternalsType  ModuleDebugMode = { "DebugMode", "Debug Mode", "bool", "%i", NULL, 0 };
#endif
AddInternal    i_ModuleDebugMode( &vpModuleInternals, &ModuleDebugMode );


#ifdef _DLL
InternalsType  CRT_Dll_Required = { "CRT_Dll_Required", "CRT Dll Required", "bool", "%i", NULL, 1 };
#else
InternalsType  CRT_Dll_Required = { "CRT_Dll_Required", "CRT Dll Required", "bool", "%i", NULL, 0 };
#endif
AddInternal    i_CRT_Dll_Required( &vpModuleInternals, &CRT_Dll_Required );

//*********************************************//
#else

#define  SetModuleLanguage   _c2( module_name, _SetModuleLanguage )
#define  CreateObject        _c2( module_name, _CreateObject )

#endif



EXPORT void SetModuleLanguage( const char *acLanguage )
{
#ifndef  module_embedded
	LoadModuleLanguage( _q(module_name), acModulePath, acLanguage, &mStrings, true );
	LoadModuleLanguage( "UtilsLib", acModulePath, acLanguage, &mStrings, false );
#else
	LoadModuleLanguage( _q(module_name), acModulePath, acLanguage, &mStrings, false );
#endif
}

EXPORT ObjectClass* CreateObject( ConfigInterface *pConfigI, const char *acType, const char *acAlias )
{
    InternalsPointersMapType::iterator it = mpModuleInternals.find( acType );
    
    if( it == mpModuleInternals.end() )
    {
        return NULL;
    }
    
	InternalsType *pInternal = it->second;
	if( !pInternal ) { return NULL; }

	InternalsPointersMapType *pmInternalsPointers = pInternal->pInternalsPointersMap;
	if( !pmInternalsPointers ) { return NULL; }

    it = (*pmInternalsPointers).find( "ObjectConstructor" ); 

    if( it == (*pmInternalsPointers).end() )
    {
        return NULL;
    }
    
	pInternal = it->second;
	if( !pInternal ) { return NULL; }

	ObjectConstructorType *pObjectConstructor = (ObjectConstructorType*)pInternal->qwData;
	if( !pObjectConstructor ) { return NULL; }

	return pObjectConstructor( pConfigI, acAlias );
}



#define  SetModuleLanguageFun      _c2( module_name, _SetModuleLanguageFun )
#define  i_SetModuleLanguageFun    _c2( i_, SetModuleLanguageFun )

InternalsType     SetModuleLanguageFun = { "SetModuleLanguage", "SetModuleLanguage function pointer", "void_DllFun_pchar", "0x%X", NULL, (qword)SetModuleLanguage };
AddInternal       i_SetModuleLanguageFun( &vpModuleInternals, &SetModuleLanguageFun );



#define   _CreateObjectFun     _c2( module_name, _CreateObjectFun )
#define  i_CreateObjectFun     _c2( i_, _CreateObjectFun )

InternalsType     _CreateObjectFun = { "CreateObject", "CreateObject function pointer", "CreateObjectFun", "0x%X", NULL, (qword)CreateObject };
AddInternal      i_CreateObjectFun( &vpModuleInternals, &_CreateObjectFun );



/*
#ifndef  module_embedded

char acXXX[] = _q(_CreateObjectFun);

InternalsType      XXX = { "XXX", "checked string", "char*", "%s", NULL, (qword)acXXX };
AddInternal      i_XXX( &vpModuleInternals, &XXX );

#endif
//*/


__if_not_exists( pConStrOut ) {
/////////////////////////////////////
void(*pConStrOut)(const char*);
/////////////////////////////////////
}


#ifndef  module_embedded
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%//

void ConStrOut( const char *str )
{
	if( pConStrOut )
	{
		return pConStrOut(str);
	}
}


EXPORT InternalsType* ModuleInit( ProgramDescriptorsType  *pProgram_Descriptors )
{
    pProgramDescriptors = pProgram_Descriptors;
	if( !pConStrOut && pProgramDescriptors->pConStrOut ) { pConStrOut = pProgramDescriptors->pConStrOut; }
	
	acProgramPath = pProgram_Descriptors->acProgramPath;

    qword *pData = const_cast< qword* >( &mpModuleInternals["ModuleHandle"]->qwData );
    *pData = (qword)ghInstance;

    InternalsType  *pModuleInternalsRoot = &ModuleInternalsRoot;
	return pModuleInternalsRoot;
}


EXPORT InternalsType* GetModuleInternalsRoot()
{
	return &ModuleInternalsRoot;
}


BOOL WINAPI DllMain ( HINSTANCE hInst, dword dwReason, LPVOID IpReserved ) 
{
	switch( dwReason ) 
	{ 
		case DLL_PROCESS_ATTACH:
		{
		 // Initialize once for each new process.
		 // Return FALSE to fail DLL load.
		 
		    pConStrOut = NULL;
		    pProgramDescriptors = NULL;
		 
        	InitCommonControls();
		 
			ghInstance = hInst;
		
			GetModuleFileName( ghInstance, acModulePath, sizeof(acModulePath) );
		
			char *pSlash = strrchr( acModulePath, '\\' );
			if( pSlash )
			{
				*(pSlash+1) = 0;
			}
			else
			{
				acModulePath[0] = 0;
			}
			
			InitInternalsPointersMaps( &ModuleInternalsRoot );
		}
		break;


		case DLL_THREAD_ATTACH:
		 // Do thread-specific initialization.
		break;

		case DLL_THREAD_DETACH:
		 // Do thread-specific cleanup.
		break;

		case DLL_PROCESS_DETACH:
		{
		 // Perform any necessary cleanup.
		    pConStrOut = NULL;
		    pProgramDescriptors = NULL;
		}
		break;
	}

	return TRUE;
}
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%//
#endif

